using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record class FaceDistanceContainer : Properties.IFaceDistanceContainer
{

    public Face Face { init; get; }
    public FaceDistance FaceDistance { init; get; }

    [JsonConstructor]
    public FaceDistanceContainer(Face face, FaceDistance faceDistance)
    {
        Face = face;
        FaceDistance = faceDistance;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}