﻿namespace View_by_Distance.Shared.Models.Stateless;

/// <summary>
/// Specifies the part of face.
/// </summary>
public enum FacePart
{

    /// <summary>
    /// Specifies the chin.
    /// </summary>
    Chin = 0,

    /// <summary>
    /// Specifies the left eyebrow.
    /// </summary>
    LeftEyebrow = 17,

    /// <summary>
    /// Specifies the right eyebrow.
    /// </summary>
    RightEyebrow = 22,

    /// <summary>
    /// Specifies the nose bridge.
    /// </summary>
    NoseBridge = 27,

    /// <summary>
    /// Specifies the nose tip.
    /// </summary>
    NoseTip = 31,

    /// <summary>
    /// Specifies the left eye.
    /// </summary>
    LeftEye = 36,

    /// <summary>
    /// Specifies the right eye.
    /// </summary>
    RightEye = 42,

    /// <summary>
    /// Specifies the top lip.
    /// </summary>
    TopLip = 48,

    /// <summary>
    /// Specifies the bottom lip.
    /// </summary>
    BottomLip = 55

}