namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IAge
{ // ...

    (int, TimeSpan) TestStatic_GetAge(long minuendTicks, long subtrahendTicks) =>
        GetAge(minuendTicks, subtrahendTicks);
    static (int, TimeSpan) GetAge(long minuendTicks, long subtrahendTicks) =>
        Age.GetAge(minuendTicks, subtrahendTicks);

    (int, TimeSpan) TestStatic_GetAge(long minuendTicks, DateTime subtrahend) =>
        GetAge(minuendTicks, subtrahend);
    static (int, TimeSpan) GetAge(long minuendTicks, DateTime subtrahend) =>
        Age.GetAge(minuendTicks, subtrahend);

    (int, TimeSpan) TestStatic_GetAge(DateTime minuend, DateTime subtrahend) =>
        GetAge(minuend, subtrahend);
    static (int, TimeSpan) GetAge(DateTime minuend, DateTime subtrahend) =>
        Age.GetAge(minuend, subtrahend);

    int? TestStatic_GetApproximateYears(char[] personCharacters, string personDisplayDirectoryName) =>
        GetApproximateYears(personCharacters, personDisplayDirectoryName);
    static int? GetApproximateYears(char[] personCharacters, string personDisplayDirectoryName) =>
        Age.GetApproximateYears(personCharacters, personDisplayDirectoryName);

}