namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IFileHolder
{

    IEnumerable<(string, string[])> TestStatic_GetFiles(string root, string searchPattern) =>
        GetFiles(root, searchPattern);
    static IEnumerable<(string, string[])> GetFiles(string root, string searchPattern) =>
        FileHolder.GetFiles(root, searchPattern);

    List<Models.FileHolder> TestStatic_GetFileHolders((string, string[])[] collection) =>
        GetFileHolders(collection);
    static List<Models.FileHolder> GetFileHolders((string, string[])[] collection) =>
        FileHolder.GetFileHolders(collection);

    IEnumerable<Models.FileHolder> TestStatic_GetFileHolders(IEnumerable<(string, string)> collection) =>
        GetFileHolders(collection);
    static IEnumerable<Models.FileHolder> GetFileHolders(IEnumerable<(string, string)> collection) =>
        FileHolder.GetFileHolders(collection);

    Models.FileHolder TestStatic_Refresh(Models.FileHolder fileHolder) =>
        Refresh(fileHolder);
    static Models.FileHolder Refresh(Models.FileHolder fileHolder) =>
        new(fileHolder.FullName);

    (int t, List<(int g, string sourceDirectory, string[] sourceDirectoryFiles)>) TestStatic_GetGroupCollection(string rootDirectory, int maxImagesInDirectoryForTopLevelFirstPass, bool reverse, string searchPattern, List<string> topDirectories) =>
        GetGroupCollection(rootDirectory, maxImagesInDirectoryForTopLevelFirstPass, reverse, searchPattern, topDirectories);
    static (int t, List<(int g, string sourceDirectory, string[] sourceDirectoryFiles)>) GetGroupCollection(string rootDirectory, int maxImagesInDirectoryForTopLevelFirstPass, bool reverse, string searchPattern, List<string> topDirectories) =>
        FileHolder.GetGroupCollection(rootDirectory, maxImagesInDirectoryForTopLevelFirstPass, reverse, searchPattern, topDirectories);

}