namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPath
{ // ...

    string TestStatic_GetRelativePath(string path, int length) =>
        GetRelativePath(path, length);
    static string GetRelativePath(string path, int length) =>
        XPath.GetRelativePath(path, length, forceExtensionToLower: false);

    bool TestStatic_DeleteEmptyDirectories(string rootDirectory) =>
        DeleteEmptyDirectories(rootDirectory);
    static bool DeleteEmptyDirectories(string rootDirectory) =>
        XPath.DeleteEmptyDirectories(rootDirectory);

    void TestStatic_DeleteEmptyDirectories(string rootDirectory, List<string> deletedDirectories) =>
        DeleteEmptyDirectories(rootDirectory, deletedDirectories);
    static void DeleteEmptyDirectories(string rootDirectory, List<string> deletedDirectories) =>
        XPath.DeleteEmptyDirectories(rootDirectory, deletedDirectories);
    // $dirs = gci "" -directory -recurse | Where { (gci $_.fullName).count -eq 0 } | select -expandproperty FullName $dirs | Foreach-Object { Remove-Item $_ }

    string[] TestStatic_GetDirectoryNames(string directory) =>
        GetDirectoryNames(directory);
    static string[] GetDirectoryNames(string directory) =>
        XPath.GetDirectoryNames(directory).ToArray();

    string TestStatic_GetRelativePath(string path, int length, bool forceExtensionToLower) =>
        GetRelativePath(path, length, forceExtensionToLower);
    static string GetRelativePath(string path, int length, bool forceExtensionToLower) =>
        XPath.GetRelativePath(path, length, forceExtensionToLower);

    bool TestStatic_WriteAllText(string path, string contents, bool updateDateWhenMatches, bool compareBeforeWrite, DateTime? updateToWhenMatches = null) =>
        WriteAllText(path, contents, updateDateWhenMatches, compareBeforeWrite, updateToWhenMatches);
    static bool WriteAllText(string path, string contents, bool updateDateWhenMatches, bool compareBeforeWrite, DateTime? updateToWhenMatches = null) =>
        XPath.WriteAllText(path, contents, updateDateWhenMatches, compareBeforeWrite, updateToWhenMatches);

    (int level, List<string> directories) TestStatic_Get(string rootDirectory, string sourceDirectory) =>
        Get(rootDirectory, sourceDirectory);
    static (int level, List<string> directories) Get(string rootDirectory, string sourceDirectory) =>
        XPath.Get(rootDirectory, sourceDirectory);

    string TestStatic_GetDirectory(string sourceDirectory, int level, string directoryName) =>
        GetDirectory(sourceDirectory, level, directoryName);
    static string GetDirectory(string sourceDirectory, int level, string directoryName) =>
        XPath.GetDirectory(sourceDirectory, level, directoryName);

}