using Microsoft.Extensions.Configuration;
using Phares.Shared;
using System.ComponentModel.DataAnnotations;
using System.Text.Json;

namespace View_by_Distance.Tests.Models.Binder;

public class Configuration
{

#nullable disable

    [Display(Name = "Check D Face and Up Dates"), Required] public bool? CheckDFaceAndUpWriteDates { get; set; }
    [Display(Name = "Check Json For Distance Results"), Required] public bool? CheckJsonForDistanceResults { get; set; }
    [Display(Name = "CrossDirectory Max Items In Distance Collection"), Required] public int? CrossDirectoryMaxItemsInDistanceCollection { get; set; }
    [Display(Name = "Distance Factor"), Required] public int? DistanceFactor { get; set; }
    [Display(Name = "Force Face Last Write Time to Creation Time"), Required] public bool? ForceFaceLastWriteTimeToCreationTime { get; set; }
    [Display(Name = "Force Metadata Last Write Time to Creation Time"), Required] public bool? ForceMetadataLastWriteTimeToCreationTime { get; set; }
    [Display(Name = "Force Resize Last Write Time to Creation Time"), Required] public bool? ForceResizeLastWriteTimeToCreationTime { get; set; }
    [Display(Name = "Ignore Extensions"), Required] public string[] IgnoreExtensions { get; set; }
    [Display(Name = "Ignore Relative Paths"), Required] public string[] IgnoreRelativePaths { get; set; }
    [Display(Name = "Julie Phares Copy Birthdays"), Required] public string[] JLinks { get; set; }
    [Display(Name = "Load Or Create Then Save Distance Results"), Required] public string[] LoadOrCreateThenSaveDistanceResultsForOutputResolutions { get; set; }
    [Display(Name = "Load Or Create Then Save Image Faces Results"), Required] public string[] LoadOrCreateThenSaveImageFacesResultsForOutputResolutions { get; set; }
    [Display(Name = "Load Or Create Then Save Index"), Required] public bool? LoadOrCreateThenSaveIndex { get; set; }
    [Display(Name = "Mapped Max Index"), Required] public int? MappedMaxIndex { get; set; }
    [Display(Name = "Mixed Year Relative Paths"), Required] public string[] MixedYearRelativePaths { get; set; }
    [Display(Name = "Model Directory"), Required] public string ModelDirectory { get; set; }
    [Display(Name = "Model Name"), Required] public string ModelName { get; set; }
    [Display(Name = "Number Jitters"), Required] public int? NumberOfJitters { get; set; }
    [Display(Name = "Number of Times To Up Sample"), Required] public int? NumberOfTimesToUpsample { get; set; }
    [Display(Name = "Output Extension"), Required] public string OutputExtension { get; set; }
    [Display(Name = "Output Quality"), Required] public int? OutputQuality { get; set; }
    [Display(Name = "Output Resolutions"), Required] public string[] OutputResolutions { get; set; }
    [Display(Name = "Override For Face Images"), Required] public bool? OverrideForFaceImages { get; set; }
    [Display(Name = "Override For Face Landmark Images"), Required] public bool? OverrideForFaceLandmarkImages { get; set; }
    [Display(Name = "Override For Resize Images"), Required] public bool? OverrideForResizeImages { get; set; }
    [Display(Name = "Predictor Model Name"), Required] public string PredictorModelName { get; set; }
    [Display(Name = "Properties Changed For Distance"), Required] public bool? PropertiesChangedForDistance { get; set; }
    [Display(Name = "Properties Changed For Faces"), Required] public bool? PropertiesChangedForFaces { get; set; }
    [Display(Name = "Properties Changed For Index"), Required] public bool? PropertiesChangedForIndex { get; set; }
    [Display(Name = "Properties Changed For Metadata"), Required] public bool? PropertiesChangedForMetadata { get; set; }
    [Display(Name = "Properties Changed For Resize"), Required] public bool? PropertiesChangedForResize { get; set; }
    [Display(Name = "Property Configuration"), Required] public Property.Models.Configuration PropertyConfiguration { get; set; }
    [Display(Name = "Reverse"), Required] public bool? Reverse { get; set; }
    [Display(Name = "Save Face Landmark For Output Resolutions"), Required] public string[] SaveFaceLandmarkForOutputResolutions { get; set; }
    [Display(Name = "Save Full Year Of Random Files"), Required] public bool? SaveFullYearOfRandomFiles { get; set; }
    [Display(Name = "Save Resized Images by Person Key Formatted"), Required] public string[] SaveFilteredOriginalImagesFromJLinksForOutputResolutions { get; set; }
    [Display(Name = "Save Shortcuts"), Required] public string[] SaveShortcutsForOutputResolutions { get; set; }
    [Display(Name = "Save Resized Subfiles"), Required] public bool? SaveResizedSubfiles { get; set; }
    [Display(Name = "Skip Search"), Required] public bool? SkipSearch { get; set; }
    [Display(Name = "Test Distance Results"), Required] public bool? TestDistanceResults { get; set; }
    [Display(Name = "Valid Resolutions"), Required] public string[] ValidResolutions { get; set; }

#nullable restore

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

    private static Models.Configuration Get(Configuration? configuration)
    {
        Models.Configuration result;
        if (configuration is null)
            throw new NullReferenceException(nameof(configuration));
        if (configuration.CheckDFaceAndUpWriteDates is null)
            throw new NullReferenceException(nameof(configuration.CheckDFaceAndUpWriteDates));
        if (configuration.CheckJsonForDistanceResults is null)
            throw new NullReferenceException(nameof(configuration.CheckJsonForDistanceResults));
        if (configuration.CrossDirectoryMaxItemsInDistanceCollection is null)
            throw new NullReferenceException(nameof(configuration.CrossDirectoryMaxItemsInDistanceCollection));
        if (configuration.DistanceFactor is null)
            throw new NullReferenceException(nameof(configuration.DistanceFactor));
        if (configuration.ForceFaceLastWriteTimeToCreationTime is null)
            throw new NullReferenceException(nameof(configuration.ForceFaceLastWriteTimeToCreationTime));
        if (configuration.ForceMetadataLastWriteTimeToCreationTime is null)
            throw new NullReferenceException(nameof(configuration.ForceMetadataLastWriteTimeToCreationTime));
        if (configuration.ForceResizeLastWriteTimeToCreationTime is null)
            throw new NullReferenceException(nameof(configuration.ForceResizeLastWriteTimeToCreationTime));
        if (configuration.IgnoreExtensions is null)
            throw new NullReferenceException(nameof(configuration.IgnoreExtensions));
        if (configuration.IgnoreRelativePaths is null)
            throw new NullReferenceException(nameof(configuration.IgnoreRelativePaths));
        configuration.LoadOrCreateThenSaveDistanceResultsForOutputResolutions ??= Array.Empty<string>();
        configuration.LoadOrCreateThenSaveImageFacesResultsForOutputResolutions ??= Array.Empty<string>();
        if (configuration.LoadOrCreateThenSaveIndex is null)
            throw new NullReferenceException(nameof(configuration.LoadOrCreateThenSaveIndex));
        if (configuration.MixedYearRelativePaths is null)
            throw new NullReferenceException(nameof(configuration.MixedYearRelativePaths));
        if (configuration.NumberOfJitters is null)
            throw new NullReferenceException(nameof(configuration.NumberOfJitters));
        if (configuration.NumberOfTimesToUpsample is null)
            throw new NullReferenceException(nameof(configuration.NumberOfTimesToUpsample));
        if (configuration.OutputQuality is null)
            throw new NullReferenceException(nameof(configuration.OutputQuality));
        if (configuration.OutputResolutions is null)
            throw new NullReferenceException(nameof(configuration.OutputResolutions));
        if (configuration.OverrideForFaceImages is null)
            throw new NullReferenceException(nameof(configuration.OverrideForFaceImages));
        if (configuration.OverrideForFaceLandmarkImages is null)
            throw new NullReferenceException(nameof(configuration.OverrideForFaceLandmarkImages));
        if (configuration.OverrideForResizeImages is null)
            throw new NullReferenceException(nameof(configuration.OverrideForResizeImages));
        if (configuration.PropertiesChangedForDistance is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForDistance));
        if (configuration.PropertiesChangedForFaces is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForFaces));
        if (configuration.PropertiesChangedForIndex is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForIndex));
        if (configuration.PropertiesChangedForMetadata is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForMetadata));
        if (configuration.PropertiesChangedForResize is null)
            throw new NullReferenceException(nameof(configuration.PropertiesChangedForResize));
        if (configuration.Reverse is null)
            throw new NullReferenceException(nameof(configuration.Reverse));
        configuration.SaveFaceLandmarkForOutputResolutions ??= Array.Empty<string>();
        if (configuration.SaveFullYearOfRandomFiles is null)
            throw new NullReferenceException(nameof(configuration.SaveFullYearOfRandomFiles));
        configuration.SaveFilteredOriginalImagesFromJLinksForOutputResolutions ??= Array.Empty<string>();
        if (configuration.SaveResizedSubfiles is null)
            throw new NullReferenceException(nameof(configuration.SaveResizedSubfiles));
        configuration.SaveShortcutsForOutputResolutions ??= Array.Empty<string>();
        if (configuration.SkipSearch is null)
            throw new NullReferenceException(nameof(configuration.SkipSearch));
        if (configuration.TestDistanceResults is null)
            throw new NullReferenceException(nameof(configuration.TestDistanceResults));
        if (configuration.ValidResolutions is null)
            throw new NullReferenceException(nameof(configuration.ValidResolutions));
        result = new(configuration.PropertyConfiguration,
                     configuration.CheckDFaceAndUpWriteDates.Value,
                     configuration.CheckJsonForDistanceResults.Value,
                     configuration.CrossDirectoryMaxItemsInDistanceCollection.Value,
                     configuration.DistanceFactor.Value,
                     configuration.ForceFaceLastWriteTimeToCreationTime.Value,
                     configuration.ForceMetadataLastWriteTimeToCreationTime.Value,
                     configuration.ForceResizeLastWriteTimeToCreationTime.Value,
                     configuration.IgnoreExtensions,
                     configuration.IgnoreRelativePaths,
                     configuration.JLinks,
                     configuration.LoadOrCreateThenSaveDistanceResultsForOutputResolutions,
                     configuration.LoadOrCreateThenSaveImageFacesResultsForOutputResolutions,
                     configuration.LoadOrCreateThenSaveIndex.Value,
                     configuration.MappedMaxIndex,
                     configuration.MixedYearRelativePaths,
                     configuration.ModelDirectory,
                     configuration.ModelName,
                     configuration.NumberOfJitters.Value,
                     configuration.NumberOfTimesToUpsample.Value,
                     configuration.OutputExtension,
                     configuration.OutputQuality.Value,
                     configuration.OutputResolutions,
                     configuration.OverrideForFaceImages.Value,
                     configuration.OverrideForFaceLandmarkImages.Value,
                     configuration.OverrideForResizeImages.Value,
                     configuration.PredictorModelName,
                     configuration.PropertiesChangedForDistance.Value,
                     configuration.PropertiesChangedForFaces.Value,
                     configuration.PropertiesChangedForIndex.Value,
                     configuration.PropertiesChangedForMetadata.Value,
                     configuration.PropertiesChangedForResize.Value,
                     configuration.Reverse.Value,
                     configuration.SaveFaceLandmarkForOutputResolutions,
                     configuration.SaveFullYearOfRandomFiles.Value,
                     configuration.SaveFilteredOriginalImagesFromJLinksForOutputResolutions,
                     configuration.SaveShortcutsForOutputResolutions,
                     configuration.SaveResizedSubfiles.Value,
                     configuration.SkipSearch.Value,
                     configuration.TestDistanceResults.Value,
                     configuration.ValidResolutions);
        return result;
    }

    public static Models.Configuration Get(IsEnvironment isEnvironment, IConfigurationRoot configurationRoot, Property.Models.Configuration propertyConfiguration)
    {
        Models.Configuration result;
        Configuration? configuration;
        if (isEnvironment is null)
            configuration = configurationRoot.Get<Configuration>();
        else
        {
            string environmentName = IsEnvironment.GetEnvironmentName(isEnvironment);
            string section = string.Concat(environmentName, ":", nameof(Configuration));
            IConfigurationSection configurationSection = configurationRoot.GetSection(section);
            configuration = configurationSection.Get<Configuration>();
        }
        result = Get(configuration);
        result.SetAndUpdate(propertyConfiguration);
        return result;
    }

}